/**********************************************************************/
/*                                                                    */
/*   Licensed Materials - Property of IBM.                            */
/*   IBM XL C/C++ for Blue Gene, V12.1                                */
/*   (5799-AG1)                                                       */
/*   Copyright IBM Corp. 2005, 2007.                                  */
/*   All Rights Reserved.                                             */
/*   US Government Users Restricted Rights -                          */
/*   Use, duplication or disclosure restricted by                     */
/*   GSA ADP Schedule Contract with IBM Corp.                         */
/*                                                                    */
/**********************************************************************/

/* NOTE:                                                              */
/*    This header is used for internal purposes only.  Any            */
/*    modifications to this file could cause severe results.          */

#ifndef __IBM_VACPP_internal__xlc_v4d_h
#define __IBM_VACPP_internal__xlc_v4d_h 1

#pragma tg_funcdef(vec_ld,qvlfdx,__vector4double,long,long*)
#pragma tg_funcdef(vec_ld,qvlfdx,__vector4double,long,unsigned long*)
#if _LONG_LONG
#pragma tg_funcdef(vec_ld,qvlfdx,__vector4double,long,long long*)
#pragma tg_funcdef(vec_ld,qvlfdx,__vector4double,long,unsigned long long*)
#endif
#pragma tg_funcdef(vec_ld, qvlfsx, __vector4double, long, float*)
#pragma tg_funcdef(vec_ld, qvlfdx, __vector4double, long, double*)
#if __C99_COMPLEX
#pragma tg_funcdef(vec_ld, qvlfsx, __vector4double, long, _Complex float*)
#pragma tg_funcdef(vec_ld, qvlfdx, __vector4double, long, _Complex double*)
#endif
#define vec_ld(a,b) __tg_builtin("vec_ld",a,b)


#pragma tg_funcdef(vec_lda,qvlfdxa,__vector4double,long,long*)
#pragma tg_funcdef(vec_lda,qvlfdxa,__vector4double,long,unsigned long*)
#if _LONG_LONG
#pragma tg_funcdef(vec_lda,qvlfdxa,__vector4double,long,long long*)
#pragma tg_funcdef(vec_lda,qvlfdxa,__vector4double,long,unsigned long long*)
#endif
#pragma tg_funcdef(vec_lda, qvlfsxa, __vector4double, long, float*)
#pragma tg_funcdef(vec_lda, qvlfdxa, __vector4double, long, double*)
#if __C99_COMPLEX
  #pragma tg_funcdef(vec_lda, qvlfsxa, __vector4double, long, _Complex float*)
  #pragma tg_funcdef(vec_lda, qvlfdxa, __vector4double, long, _Complex double*)
#endif
#define vec_lda(a,b) __tg_builtin("vec_lda",a,b)


#pragma tg_funcdef(vec_lds, qvlfsxs, __vector4double, long, float*)
#pragma tg_funcdef(vec_lds, qvlfdxs, __vector4double, long, double*)
#if __C99_COMPLEX
#pragma tg_funcdef(vec_lds, qvlfcsx, __vector4double, long, _Complex float*)
#pragma tg_funcdef(vec_lds, qvlfcdx, __vector4double, long, _Complex double*)
#endif
#define vec_lds(a,b) __tg_builtin("vec_lds",a,b)


#if __C99_COMPLEX
#pragma tg_funcdef(vec_ldsa, qvlfcsxa, __vector4double, long, _Complex float*)
#pragma tg_funcdef(vec_ldsa, qvlfcdxa, __vector4double, long, _Complex double*)
#endif
#define vec_ldsa(a,b) __tg_builtin("vec_ldsa",a,b)

#pragma tg_funcdef(vec_ldia,qvlfiwax,__vector4double,long,int*)
#define vec_ldia(a,b) __tg_builtin("vec_ldia",a,b)


#pragma tg_funcdef(vec_ldiaa,qvlfiwaxa,__vector4double,long,int*)
#define vec_ldiaa(a,b) __tg_builtin("vec_ldiaa",a,b)

#pragma tg_funcdef(vec_ldiz,qvlfiwzx,__vector4double,long,unsigned int*)
#define vec_ldiz(a,b) __tg_builtin("vec_ldiz",a,b)


#pragma tg_funcdef(vec_ldiza,qvlfiwzxa,__vector4double,long,unsigned int*)
#define vec_ldiza(a,b) __tg_builtin("vec_ldiza",a,b)


#pragma tg_funcdef(vec_lvsl, qvlpclsx, __vector4double, long, float*)
#pragma tg_funcdef(vec_lvsl, qvlpcldx, __vector4double, long, double*)
#if __C99_COMPLEX
#pragma tg_funcdef(vec_lvsl, qvlpclsx, __vector4double, long, _Complex float*)
#pragma tg_funcdef(vec_lvsl, qvlpcldx, __vector4double, long, _Complex double*)
#endif
#define vec_lvsl(a,b) __tg_builtin("vec_lvsl",a,b)


#pragma tg_funcdef(vec_lvsr, qvlpcrsx, __vector4double, long, float*)
#pragma tg_funcdef(vec_lvsr, qvlpcrdx, __vector4double, long, double*)
#if __C99_COMPLEX
#pragma tg_funcdef(vec_lvsr, qvlpcrsx, __vector4double, long, _Complex float*)
#pragma tg_funcdef(vec_lvsr, qvlpcrdx, __vector4double, long, _Complex double*)
#endif
#define vec_lvsr(a,b) __tg_builtin("vec_lvsr",a,b)


#pragma tg_funcdef(vec_st,qvstfiwx,void,__vector4double,long,int*)
#pragma tg_funcdef(vec_st,qvstfiwx,void,__vector4double,long,unsigned*)
#pragma tg_funcdef(vec_st,qvstfdx,void,__vector4double,long,long*)
#pragma tg_funcdef(vec_st,qvstfdx,void,__vector4double,long,unsigned long*)
#if _LONG_LONG
#pragma tg_funcdef(vec_st,qvstfdx,void,__vector4double,long,long long*)
#pragma tg_funcdef(vec_st,qvstfdx,void,__vector4double,long,unsigned long long*)
#endif
#pragma tg_funcdef(vec_st, qvstfsx, void, __vector4double, long, float*)
#pragma tg_funcdef(vec_st, qvstfdx, void, __vector4double, long, double*)
#if __C99_COMPLEX
#pragma tg_funcdef(vec_st, qvstfsx, void, __vector4double, long, _Complex float*)
#pragma tg_funcdef(vec_st, qvstfdx, void, __vector4double, long, _Complex double*)
#endif
#define vec_st(a,b,c) __tg_builtin("vec_st",a,b,c)


#pragma tg_funcdef(vec_sta,qvstfiwxa,void,__vector4double,long,int*)
#pragma tg_funcdef(vec_sta,qvstfiwxa,void,__vector4double,long,unsigned*)
#pragma tg_funcdef(vec_sta,qvstfdxa,void,__vector4double,long,long*)
#pragma tg_funcdef(vec_sta,qvstfdxa,void,__vector4double,long,unsigned long*)
#if _LONG_LONG
#pragma tg_funcdef(vec_sta,qvstfdxa,void,__vector4double,long,long long*)
#pragma tg_funcdef(vec_sta,qvstfdxa,void,__vector4double,long,unsigned long long*)
#endif
#pragma tg_funcdef(vec_sta, qvstfsxa, void, __vector4double, long, float*)
#pragma tg_funcdef(vec_sta, qvstfdxa, void, __vector4double, long, double*)
#if __C99_COMPLEX
#pragma tg_funcdef(vec_sta, qvstfsxa, void, __vector4double, long, _Complex float*)
#pragma tg_funcdef(vec_sta, qvstfdxa, void, __vector4double, long, _Complex double*)
#endif
#define vec_sta(a,b,c) __tg_builtin("vec_sta",a,b,c)


#pragma tg_funcdef(vec_sts, qvstfsxs, void, __vector4double, long, float*)
#pragma tg_funcdef(vec_sts, qvstfdxs, void, __vector4double, long, double*)
#if __C99_COMPLEX
#pragma tg_funcdef(vec_sts, qvstfcsx, void, __vector4double, long, _Complex float*)
#pragma tg_funcdef(vec_sts, qvstfcdx, void, __vector4double, long, _Complex double*)
#endif
#define vec_sts(a,b,c) __tg_builtin("vec_sts",a,b,c)


#if __C99_COMPLEX
#pragma tg_funcdef(vec_stsa, qvstfcsxa, void, __vector4double, long, _Complex float*)
#pragma tg_funcdef(vec_stsa, qvstfcdxa, void, __vector4double, long, _Complex double*)
#endif
#define vec_stsa(a,b,c) __tg_builtin("vec_stsa",a,b,c)


#pragma tg_funcdef(vec_ld2, qvlfcsx, __vector4double, long, float*)
#pragma tg_funcdef(vec_ld2, qvlfcdx, __vector4double, long, double*)
#define vec_ld2(a,b) __tg_builtin("vec_ld2",a,b)


#pragma tg_funcdef(vec_ld2a, qvlfcsxa, __vector4double, long, float*)
#pragma tg_funcdef(vec_ld2a, qvlfcdxa, __vector4double, long, double*)
#define vec_ld2a(a,b) __tg_builtin("vec_ld2a",a,b)


#pragma tg_funcdef(vec_st2, qvstfcsx, void, __vector4double, long, float*)
#pragma tg_funcdef(vec_st2, qvstfcdx, void, __vector4double, long, double*)
#define vec_st2(a,b,c) __tg_builtin("vec_st2",a,b,c)


#pragma tg_funcdef(vec_st2a, qvstfcsxa, void, __vector4double, long, float*)
#pragma tg_funcdef(vec_st2a, qvstfcdxa, void, __vector4double, long, double*)
#define vec_st2a(a,b,c) __tg_builtin("vec_st2a",a,b,c)

#pragma tg_funcdef(vec_neg, qvfneg, __vector4double, __vector4double)
#define vec_neg(a) __tg_builtin("vec_neg",a)


#pragma tg_funcdef(vec_abs,qvfabs, __vector4double, __vector4double)
#define vec_abs(a) __tg_builtin("vec_abs",a)


#pragma tg_funcdef(vec_nabs, qvfnabs, __vector4double, __vector4double)
#define vec_nabs(a) __tg_builtin("vec_nabs",a)


#pragma tg_funcdef(vec_add, qvfadd, __vector4double, __vector4double, __vector4double)
#define vec_add(a,b) __tg_builtin("vec_add",a,b)


#pragma tg_funcdef(vec_sub, qvfsub, __vector4double, __vector4double, __vector4double)
#define vec_sub(a,b) __tg_builtin("vec_sub",a,b)


#pragma tg_funcdef(vec_mul, qvfmul, __vector4double, __vector4double, __vector4double)
#define vec_mul(a,b) __tg_builtin("vec_mul",a,b)


#pragma tg_funcdef(vec_re, qvfre,  __vector4double, __vector4double)
#define vec_re(a) __tg_builtin("vec_re",a)


#pragma tg_funcdef(vec_res, qvfres,  __vector4double, __vector4double)
#define vec_res(a) __tg_builtin("vec_res",a)


#pragma tg_funcdef(vec_rsqrte, qvfrsqrte,  __vector4double, __vector4double)
#define vec_rsqrte(a) __tg_builtin("vec_rsqrte",a)

#pragma tg_funcdef(vec_rsqrtes, qvfrsqrtes,  __vector4double, __vector4double)
#define vec_rsqrtes(a) __tg_builtin("vec_rsqrtes",a)

#pragma tg_funcdef(vec_madd, qvfmadd, __vector4double, __vector4double, __vector4double, __vector4double)
#define vec_madd(a,b,c) __tg_builtin("vec_madd",a,b,c)

#pragma tg_funcdef(vec_msub, qvfmsub, __vector4double, __vector4double, __vector4double, __vector4double)
#define vec_msub(a,b,c) __tg_builtin("vec_msub",a,b,c)

#pragma tg_funcdef(vec_nmadd, qvfnmadd, __vector4double, __vector4double, __vector4double, __vector4double)
#define vec_nmadd(a,b,c) __tg_builtin("vec_nmadd",a,b,c)

#pragma tg_funcdef(vec_nmsub, qvfnmsub, __vector4double, __vector4double, __vector4double, __vector4double)
#define vec_nmsub(a,b,c) __tg_builtin("vec_nmsub",a,b,c)

#pragma tg_funcdef(vec_xmadd, qvfxmadd, __vector4double, __vector4double, __vector4double, __vector4double)
#define vec_xmadd(a,b,c) __tg_builtin("vec_xmadd",a,b,c)

#pragma tg_funcdef(vec_xxnpmadd, qvfxxnpmadd,  __vector4double, __vector4double, __vector4double, __vector4double)
#define vec_xxnpmadd(a,b,c) __tg_builtin("vec_xxnpmadd",a,b,c)

#pragma tg_funcdef(vec_rsp, qvfrsp, __vector4double, __vector4double)
#define vec_rsp(a) __tg_builtin("vec_rsp",a)

#pragma tg_funcdef(vec_ctid, qvfctid, __vector4double, __vector4double)
#define vec_ctid(a) __tg_builtin("vec_ctid",a)

#pragma tg_funcdef(vec_ctidu, qvfctidu, __vector4double, __vector4double)
#define vec_ctidu(a) __tg_builtin("vec_ctidu",a)

#pragma tg_funcdef(vec_ctidz, qvfctidz, __vector4double, __vector4double)
#define vec_ctidz(a) __tg_builtin("vec_ctidz",a)

#pragma tg_funcdef(vec_ctiduz, qvfctiduz, __vector4double, __vector4double)
#define vec_ctiduz(a) __tg_builtin("vec_ctiduz",a)

#pragma tg_funcdef(vec_ctiw, qvfctiw, __vector4double, __vector4double)
#define vec_ctiw(a) __tg_builtin("vec_ctiw",a)

#pragma tg_funcdef(vec_ctiwu, qvfctiwu, __vector4double, __vector4double)
#define vec_ctiwu(a) __tg_builtin("vec_ctiwu",a)

#pragma tg_funcdef(vec_ctiwz, qvfctiwz, __vector4double, __vector4double)
#define vec_ctiwz(a) __tg_builtin("vec_ctiwz",a)

#pragma tg_funcdef(vec_ctiwuz, qvfctiwuz, __vector4double, __vector4double)
#define vec_ctiwuz(a) __tg_builtin("vec_ctiwuz",a)

#pragma tg_funcdef(vec_cfid, qvfcfid, __vector4double, __vector4double)
#define vec_cfid(a) __tg_builtin("vec_cfid",a)

#pragma tg_funcdef(vec_cfidu, qvfcfidu, __vector4double, __vector4double)
#define vec_cfidu(a) __tg_builtin("vec_cfidu",a)

#pragma tg_funcdef(vec_tstnan, qvftstnan, __vector4double, __vector4double, __vector4double)
#define vec_tstnan(a,b) __tg_builtin("vec_tstnan",a,b)

#pragma tg_funcdef(vec_cmpgt, qvfcmpgt, __vector4double, __vector4double, __vector4double)
#define vec_cmpgt(a,b) __tg_builtin("vec_cmpgt",a,b)

#pragma tg_funcdef(vec_cmplt, qvfcmplt, __vector4double, __vector4double, __vector4double)
#define vec_cmplt(a,b) __tg_builtin("vec_cmplt",a,b)

#pragma tg_funcdef(vec_cmpeq, qvfcmpeq, __vector4double, __vector4double, __vector4double)
#define vec_cmpeq(a,b) __tg_builtin("vec_cmpeq",a,b)

#pragma tg_funcdef(vec_sel, qvfsel, __vector4double, __vector4double, __vector4double, __vector4double)
#define vec_sel(a,b,c) __tg_builtin("vec_sel",a,b,c)

#pragma tg_funcdef(vec_sldw, qvaligni, __vector4double, __vector4double, __vector4double,int)
#define vec_sldw(a,b,c) __tg_builtin("vec_sldw",a,b,c)

#pragma tg_funcdef(vec_perm, qvfperm, __vector4double, __vector4double, __vector4double, __vector4double)
#define vec_perm(a,b,c) __tg_builtin("vec_perm",a,b,c)

#pragma tg_funcdef(vec_splat, qvesplati, __vector4double, __vector4double, int)
#define vec_splat(a,b) __tg_builtin("vec_splat",a,b)

#pragma tg_funcdef(vec_splats, qvfsplats, __vector4double, double)
#define vec_splats(a) __tg_builtin("vec_splats",a)

#pragma tg_funcdef(vec_gpci, qvgpci, __vector4double, int)
#define vec_gpci(a) __tg_builtin("vec_gpci",a)

#pragma tg_funcdef(vec_and, qvfand, __vector4double, __vector4double, __vector4double)
#define vec_and(a,b) __tg_builtin("vec_and",a,b)

#pragma tg_funcdef(vec_andc, qvfandc, __vector4double, __vector4double, __vector4double)
#define vec_andc(a,b) __tg_builtin("vec_andc",a,b)

#pragma tg_funcdef(vec_nand, qvfnand, __vector4double, __vector4double, __vector4double)
#define vec_nand(a,b) __tg_builtin("vec_nand",a,b)

#pragma tg_funcdef(vec_or, qvfor, __vector4double, __vector4double, __vector4double)
#define vec_or(a,b) __tg_builtin("vec_or",a,b)

#pragma tg_funcdef(vec_orc, qvforc, __vector4double, __vector4double, __vector4double)
#define vec_orc(a,b) __tg_builtin("vec_orc",a,b)

#pragma tg_funcdef(vec_xor, qvfxor, __vector4double, __vector4double, __vector4double)
#define vec_xor(a,b) __tg_builtin("vec_xor",a,b)

#pragma tg_funcdef(vec_not, qvfnot, __vector4double, __vector4double)
#define vec_not(a) __tg_builtin("vec_not",a)

#pragma tg_funcdef(vec_nor, qvfnor, __vector4double, __vector4double, __vector4double)
#define vec_nor(a,b) __tg_builtin("vec_nor",a,b)

#pragma tg_funcdef(vec_logical, qvflogical, __vector4double, __vector4double, __vector4double, int)
#define vec_logical(a,b,c) __tg_builtin("vec_logical",a,b,c)

#pragma tg_funcdef(vec_cpsgn, qvfcpsgn, __vector4double, __vector4double, __vector4double)
#define vec_cpsgn(a,b) __tg_builtin("vec_cpsgn",a,b)

#pragma tg_funcdef(vec_xxcpnmadd, qvfxxcpnmadd, __vector4double, __vector4double, __vector4double, __vector4double)
#define vec_xxcpnmadd(a,b,c) __tg_builtin("vec_xxcpnmadd",a,b,c)

#pragma tg_funcdef(vec_xxmadd, qvfxxmadd, __vector4double, __vector4double, __vector4double, __vector4double)
#define vec_xxmadd(a,b,c) __tg_builtin("vec_xxmadd",a,b,c)

#pragma tg_funcdef(vec_xmul, qvfxmul, __vector4double, __vector4double, __vector4double)
#define vec_xmul(a,b) __tg_builtin("vec_xmul",a,b)

#pragma tg_funcdef(vec_swdiv, qvfswdiv, __vector4double, __vector4double, __vector4double)
#define vec_swdiv(a,b) __tg_builtin("vec_swdiv",a,b)

#pragma tg_funcdef(vec_swdivs, qvfswdivs, __vector4double, __vector4double, __vector4double)
#define vec_swdivs(a,b) __tg_builtin("vec_swdivs",a,b)

#pragma tg_funcdef(vec_swdiv_nochk, qvfswdiv_nochk, __vector4double, __vector4double, __vector4double)
#define vec_swdiv_nochk(a,b) __tg_builtin("vec_swdiv_nochk",a,b)

#pragma tg_funcdef(vec_swdivs_nochk, qvfswdivs_nochk, __vector4double, __vector4double, __vector4double)
#define vec_swdivs_nochk(a,b) __tg_builtin("vec_swdivs_nochk",a,b)

#pragma tg_funcdef(vec_swsqrt, qvfswsqrt, __vector4double, __vector4double)
#define vec_swsqrt(a) __tg_builtin("vec_swsqrt",a)

#pragma tg_funcdef(vec_swsqrts, qvfswsqrts, __vector4double, __vector4double)
#define vec_swsqrts(a) __tg_builtin("vec_swsqrts",a)

#pragma tg_funcdef(vec_swsqrt_nochk, qvfswsqrt_nochk, __vector4double, __vector4double)
#define vec_swsqrt_nochk(a) __tg_builtin("vec_swsqrt_nochk",a)

#pragma tg_funcdef(vec_swsqrts_nochk, qvfswsqrts_nochk, __vector4double, __vector4double)
#define vec_swsqrts_nochk(a) __tg_builtin("vec_swsqrts_nochk",a)

#pragma tg_funcdef(vec_round, qvfrin, __vector4double, __vector4double)
#define vec_round(a) __tg_builtin("vec_round",a)

#pragma tg_funcdef(vec_trunc, qvfriz, __vector4double, __vector4double)
#define vec_trunc(a) __tg_builtin("vec_trunc",a)

#pragma tg_funcdef(vec_ceil, qvfrip, __vector4double, __vector4double)
#define vec_ceil(a) __tg_builtin("vec_ceil",a)

#pragma tg_funcdef(vec_floor, qvfrim, __vector4double, __vector4double)
#define vec_floor(a) __tg_builtin("vec_floor",a)

#pragma tg_funcdef(vec_extract, qvfextract, double, __vector4double, int)
#define vec_extract(a,b) __tg_builtin("vec_extract",a,b)

#pragma tg_funcdef(vec_insert, qvfinsert, __vector4double, double, __vector4double, int)
#define vec_insert(a,b,c) __tg_builtin("vec_insert",a,b,c)

#pragma tg_funcdef(vec_promote, qvfpromote, __vector4double, double, int)
#define vec_promote(a,b) __tg_builtin("vec_promote",a,b)

#endif
