/********************************************************************/
/* Licensed Materials - Property of IBM                             */
/* IBM MASS Library Component V7.3 for Blue Gene                    */
/* 5799-AG1                                                         */
/* 5799-AH1                                                         */
/* Copyright IBM Corp. 2007, 2011.                                  */
/* US Government Users Restricted Rights - Use, duplication or      */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.*/
/********************************************************************/

/* SCCS ID STRING    %M%  %I% %G% %U%        %H% %T% */

#ifdef __cplusplus
  extern "C" {
#endif

#ifndef __cplusplus
# include <complex.h>
#endif

void vsacos(float *z, float *x, int *n);
void vsacosh(float *z, float *x, int *n);
void vsasin(float *z, float *x, int *n);
void vsasinh(float *z, float *x, int *n);
void vsatan(float *z, float *x, int *n);
void vsatan2(float *z, float *x, float *y, int *n);
void vsatanh(float *z, float *x, int *n);
void vscbrt(float *z, float *x, int *n);
void vscos(float *z, float *x, int *n);
void vscosh(float *z, float *x, int *n);
void vscosisin(float _Complex *z, float *x, int *n);
void vsdiv(float *z, float *x, float *y, int *n);
void vserf(float *z, float *x, int *n);
void vserfc(float *z, float *x, int *n);
void vsexp(float *z, float *x, int *n);
void vsexp2(float *z, float *x, int *n);
void vsexp2m1(float *z, float *x, int *n);
void vsexpm1(float *z, float *x, int *n);
void vshypot(float *z, float *x, float *y, int *n);
void vslgamma(float *z, float *x, int *n);
void vslog(float *z, float *x, int *n);
void vslog10(float *z, float *x, int *n);
void vslog1p(float *z, float *x, int *n);
void vslog2(float *z, float *x, int *n);
void vslog21p(float *z, float *x, int *n);
void vspow(float *z, float *x, float *y, int *n);
void vsqdrt(float *z, float *x, int *n);
void vsrcbrt(float *z, float *x, int *n);
void vsrec(float *z, float *x, int *n);
void vsrqdrt(float *z, float *x, int *n);
void vsrsqrt(float *z, float *x, int *n);
void vssin(float *z, float *x, int *n);
void vssincos(float *zsin, float *zcos, float *x, int *n);
void vssinh(float *z, float *x, int *n);
void vssqrt(float *z, float *x, int *n);
void vstan(float *z, float *x, int *n);
void vstanh(float *z, float *x, int *n);

void vacos(double *z, double *x, int *n);
void vacosh(double *z, double *x, int *n);
void vasin(double *z, double *x, int *n);
void vasinh(double *z, double *x, int *n);
void vatan(double *z, double *x, int *n);
void vatan2(double *z, double *x, double *y, int *n);
void vatanh(double *z, double *x, int *n);
void vcbrt(double *z, double *x, int *n);
void vcos(double *z, double *x, int *n);
void vcosh(double *z, double *x, int *n);
void vcosisin(double _Complex *z, double *x, int *n);
void vdiv(double *z, double *x, double *y, int *n);
void verf(double *z, double *x, int *n);
void verfc(double *z, double *x, int *n);
void vexp(double *z, double *x, int *n);
void vexp2(double *z, double *x, int *n);
void vexp2m1(double *z, double *x, int *n);
void vexpm1(double *z, double *x, int *n);
void vhypot(double *z, double *x, double *y, int *n);
void vlgamma(double *z, double *x, int *n);
void vlog(double *z, double *x, int *n);
void vlog10(double *z, double *x, int *n);
void vlog1p(double *z, double *x, int *n);
void vlog2(double *z, double *x, int *n);
void vlog21p(double *z, double *x, int *n);
void vpow(double *z, double *x, double *y, int *n);
void vqdrt(double *z, double *x, int *n);
void vrcbrt(double *z, double *x, int *n);
void vrec(double *z, double *x, int *n);
void vrqdrt(double *z, double *x, int *n);
void vrsqrt(double *z, double *x, int *n);
void vsin(double *z, double *x, int *n);
void vsincos(double *zsin, double *zcos, double *x, int *n);
void vsinh(double *z, double *x, int *n);
void vsqrt(double *z, double *x, int *n);
void vtan(double *z, double *x, int *n);
void vtanh(double *z, double *x, int *n);

int vpopcnt4(int *x, int *n);
int vpopcnt8(long long *x, int *n);

#ifdef __cplusplus
}
#endif
